﻿Structure TVersenyző
    Dim Mez As Integer       ' a versenyző mezének sorszáma
    Dim Szín As ConsoleColor ' a versenyző mezének színe
    Dim Helyzet As Integer   ' a versenyző pozíciója a pályán
    Dim Szóközök As String   ' az előző helyzet törléséhez
End Structure

Module Module1
    Const MaxLépés As Integer = 6
    Const Szünet As Integer = 500 ' várakozás ezredmásodpercben a lépések között
    Dim Hossz As Integer ' a pálya hossza
    Dim Színek() As ConsoleColor = {ConsoleColor.Gray, ConsoleColor.Green, ConsoleColor.Cyan, _
                                        ConsoleColor.Red, ConsoleColor.Magenta, ConsoleColor.Yellow, ConsoleColor.White}
    Dim Vélszám As Random
    Dim Győztesek As SortedSet(Of Integer)
    Dim VersenyzőkSzáma As Integer ' a versenyzők száma
    Dim Versenyzők() As TVersenyző

    Sub Main()
        Vélszám = New Random
        Start()
    End Sub

    Sub Start()
        Console.Title = "Futóverseny"
        ' Beolvassuk a versenyzők számát:
        Console.Write("A versenyzők száma (<" & Console.LargestWindowHeight - 9 & "): ")
        VersenyzőkSzáma = Console.ReadLine()
        ' Méretezzük a versenyzőket tartalmazó tömböt és értéket adunk a versenyzők tulajdonságainak:
        ReDim Versenyzők(VersenyzőkSzáma)
        For I = 1 To VersenyzőkSzáma
            VersenyzőLétrehoz(Versenyzők(I), I)
        Next
        ' Kirajzoljuk a pályát:
        PályaLétrehoz(VersenyzőkSzáma)
        ' Elindítjuk a versenyt:
        Győztesek = New SortedSet(Of Integer)
        Futás()
        ' Kiírjuk a győzteseket:
        Eredmény()
        Console.Write("(Enter: kilép)")
        Console.ReadLine()
    End Sub

    Sub VersenyzőLétrehoz(ByRef Versenyző As TVersenyző, ByVal Sorszám As Integer)
        Versenyző.Mez = Sorszám
        Versenyző.Szín = Színek(Vélszám.Next(0, Színek.Length))
        Versenyző.Helyzet = 0
        Versenyző.Szóközök = Space(Versenyző.Mez.ToString.Length) ' a mezszám karaktereinek a száma
    End Sub

    Sub PályaLétrehoz(ByVal VersenyzőkSzáma As Integer)
        ' Az ablak méretének módosítása:
        Hossz = Console.WindowWidth - 10
        Console.WindowHeight = VersenyzőkSzáma + 5
        ' A célvonal kirajzolása:
        Console.Clear()
        Console.ForegroundColor = ConsoleColor.Yellow
        For I = 1 To VersenyzőkSzáma
            Console.SetCursorPosition(Hossz, I - 1)
            Console.Write("|")
        Next
    End Sub

    Private Sub Futás()
        Do
            Console.CursorTop = 0
            For I = 1 To VersenyzőkSzáma
                Fut(Versenyzők(I))
            Next
            Vár(Szünet)
        Loop While Győztesek.Count = 0
        Console.ForegroundColor = ConsoleColor.Gray
        Console.WriteLine("Vége a versenynek.")
    End Sub

    Private Sub Eredmény()
        Console.Write("Győzött: ")
        For Each Elem In Győztesek
            Console.Write(Elem & " ")
        Next
        Console.WriteLine()
    End Sub

    Sub Fut(ByRef Versenyző As TVersenyző)
        Console.CursorLeft = Versenyző.Helyzet
        Console.Write(Versenyző.Szóközök) ' letöröljük az előző helyet
        Versenyző.Helyzet += Vélszám.Next(1, MaxLépés + 1)
        If Versenyző.Helyzet >= Hossz Then ' a versenyző beért a célba
            Győztesek.Add(Versenyző.Mez)
            ' Töröljük a célvonalat a versenyző sorában:
            Console.CursorLeft = Hossz
            Console.Write(" ")
        End If
        Kiír(Versenyző)
    End Sub

    Private Sub Vár(ByVal Időtartam As Integer)
        Threading.Thread.Sleep(Időtartam)
    End Sub

    Sub Kiír(ByVal Versenyző As TVersenyző)
        ' Megjelenítjük a versenyző helyzetét:
        Console.CursorLeft = Versenyző.Helyzet
        Console.ForegroundColor = Versenyző.Szín
        Console.WriteLine(Versenyző.Mez)
    End Sub

End Module
