﻿Public Class TVerseny
    Private Const Szünet As Integer = 500 ' várakozás ezredmásodpercben a lépések között
    Public Pálya As TPálya
    Private Győztesek As SortedSet(Of Integer)
    Private N As Integer ' a versenyzők száma
    Private Versenyzők() As TVersenyző

    Private Property VersenyzőkSzáma() As Integer
        Get
            VersenyzőkSzáma = N
        End Get
        Set(ByVal érték As Integer)
            If 0 < érték And érték < Console.LargestWindowHeight - 9 Then
                N = érték
            Else
                N = 0
            End If
        End Set
    End Property

    Public WriteOnly Property Győz() As Integer
        Set(ByVal érték As Integer)
            If 0 < érték And érték <= VersenyzőkSzáma Then
                Győztesek.Add(érték)
            End If
        End Set
    End Property

    Public Sub Start()
        Console.Title = "Futóverseny"
        ' Beolvassuk a versenyzők számát:
        Do
            Console.Write("A versenyzők száma (<" & Console.LargestWindowHeight - 9 & "): ")
            VersenyzőkSzáma = Console.ReadLine()
        Loop While VersenyzőkSzáma = 0
        ' Méretezzük a versenyzőket tartalmazó tömböt és létrehozzuk a versenyzőobjektumokat (tömbelemek):
        ReDim Versenyzők(VersenyzőkSzáma)
        For I = 1 To VersenyzőkSzáma
            Versenyzők(I) = New TVersenyző(I)
        Next
        ' Létrehozzuk a pályaobjektumot:
        Pálya = New TPálya(VersenyzőkSzáma)
        ' Elindítjuk a versenyt:
        Győztesek = New SortedSet(Of Integer)
        Futás()
        ' Kiírjuk a győzteseket:
        Eredmény()
        Console.Write("(Enter: kilép)")
        Console.ReadLine()
    End Sub

    Private Sub Futás()
        Do
            Console.CursorTop = 0
            For I = 1 To VersenyzőkSzáma
                Versenyzők(I).Fut(Me)
            Next
            Vár(Szünet)
        Loop While Győztesek.Count = 0
        Console.ForegroundColor = ConsoleColor.Gray
        Console.WriteLine("Vége a versenynek.")
    End Sub

    Private Sub Eredmény()
        Console.Write("Győzött: ")
        For Each Elem In Győztesek
            Console.Write(Elem & " ")
        Next
        Console.WriteLine()
    End Sub

    Private Sub Vár(ByVal Időtartam As Integer)
        Threading.Thread.Sleep(Időtartam)
    End Sub
End Class