﻿Public MustInherit Class TElem
    Protected Shared Property SzomszédKáposzta As Boolean ' van-e szomszédos cellán káposzta
    Protected Shared Property SzomszédNyúl As Boolean     ' van-e szomszédos cellán nyúl
    Protected Shared Property SzomszédRóka As Boolean     ' van-e szomszédos cellán róka
    Protected Property X As Integer ' az elem X koordinátája
    Protected Property Y As Integer ' az elem Y koordinátája
    Protected Property Szín As ConsoleColor ' az elem színe
    Protected Overridable Property Jel As String = " "

    Friend Sub New(ByVal X As Integer, ByVal Y As Integer)
        Me.X = X
        Me.Y = Y
    End Sub

    Friend MustOverride Function Újelem() As TElem
    ' a polimorfizmus miatt elhelyezzük itt a függvény definícióját
    ' (így a TElem típusú objektumoknak van Újelem metódusa)

    Protected Sub Szomszédok()
        SzomszédKáposzta = False
        SzomszédNyúl = False
        SzomszédRóka = False
        Vizsgál(Játék.Tábla(X, Y - 1)) ' balra
        Vizsgál(Játék.Tábla(X, Y + 1)) ' jobbra
        Vizsgál(Játék.Tábla(X - 1, Y)) ' felette
        Vizsgál(Játék.Tábla(X + 1, Y)) ' alatta
    End Sub

    Private Sub Vizsgál(ByVal Szomszéd As TElem)
        SzomszédKáposzta = SzomszédKáposzta Or (TypeOf Szomszéd Is TKáposzta)
        SzomszédNyúl = SzomszédNyúl Or (TypeOf Szomszéd Is TNyúl)
        SzomszédRóka = SzomszédRóka Or (TypeOf Szomszéd Is TRóka)
    End Sub

    Friend Sub Kiír()
        Console.CursorTop = X
        Console.CursorLeft = Y
        Console.Write(Me)
    End Sub

    Public Overrides Function ToString() As String
        Console.ForegroundColor = Szín ' utána illene visszaállítani az eredeti színre
        ToString = Jel
    End Function
End Class
