﻿' Egyenletmegoldás különböző stratégiákkal
' A stratégiákat az egyenletmegoldás különböző módszereivel szimuláljuk.

Public Class Form1
    Dim Vélszám As New Random
    Dim Lépésszám As Integer
    Dim Temp As Single

    Function F(ByVal X As Single) As Single
        F = 2 * X ^ 4 - X ^ 3 - 4 * X ^ 2 + 2
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' Nyers erő (kiválasztás ~ lineáris keresés)
        ' Addig megyünk előre, amíg rá nem találunk a kívánt pontosságú megoldásra.
        Dim I As Integer
        Lépésszám = 0
        I = 0
        Do While F(I / 100) > 0
            I += 1
            Lépésszám += 1
        Loop
        Label1.Text = "A megoldás intervalluma: [" & (I - 1) / 100 & "; " & I / 100 & "]" & vbNewLine
        Label1.Text &= "x = " & I / 100 - 0.005 & vbNewLine
        Label1.Text &= "Hibakorlát: " & 0.005 & vbNewLine
        Label1.Text &= "Lépésszám: " & Lépésszám
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ' Oszd meg és uralkodj (intervallumfelezés ~ bináris keresés)
        ' Mikor talál rá viszonylag lassan a megoldásra?
        Dim Kezd, Vég, Közép As Single
        Lépésszám = 0
        Kezd = 0
        Vég = 1
        Do While Math.Abs(Kezd - Vég) >= 0.01
            Közép = (Kezd + Vég) / 2
            If F(Közép) > 0 Then
                Kezd = Közép
            Else
                Vég = Közép
            End If
            Lépésszám += 1
        Loop
        Label2.Text = "A megoldás intervalluma: [" & Kezd & "; " & Vég & "]" & vbNewLine
        Label2.Text &= "x = " & (Kezd + Vég) / 2 & vbNewLine
        Label2.Text &= "Hibakorlát: " & (Vég - Kezd) / 2 & vbNewLine
        Label2.Text &= "Lépésszám: " & Lépésszám

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ' Véletlenített
        ' Lényegében intervallum-"felezés", de az osztópontot felezés helyett véletlenszám választásával jelöljük ki.
        ' Előfordul az intervallumfelezésnél kevesebb lépésszám?
        Dim Kezd, Vég, Osztópont As Single
        Lépésszám = 0
        Kezd = 0
        Vég = 1
        Do While Vég - Kezd >= 0.01
            Osztópont = Kezd + Vélszám.NextDouble * (Vég - Kezd)
            If F(Osztópont) > 0 Then
                Kezd = Osztópont
            Else
                Vég = Osztópont
            End If
            Lépésszám += 1
        Loop
        Label3.Text = "A megoldás intervalluma: [" & Kezd & "; " & Vég & "]" & vbNewLine
        Label3.Text &= "x = " & (Kezd + Vég) / 2 & vbNewLine
        Label3.Text &= "Hibakorlát: " & (Vég - Kezd) / 2 & vbNewLine
        Label3.Text &= "Lépésszám: " & Lépésszám
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        ' Heurisztikus
        ' Lényegében intervallum-"felezés", de a felezőpont helyett a húr és az x-tengely metszéspontját vesszük újabb osztópontnak, illetve közelítő megoldásnak.
        ' Heurisztika: feltételezzük, hogy az aktuális intervallum két végpontjában a függvényértékeket összekötő húr és az x-tengely metszéspontja közelében van a megoldás.
        ' (mikor nem igaz?)
        ' Mi az előnye és mi a hátránya a többi módszerrel szemben?
        Dim Kezd, Vég, Osztópont, Előző As Single
        Lépésszám = 0
        Kezd = 0
        Vég = 1
        Osztópont = 0
        Do
            Előző = Osztópont
            Osztópont = Kezd - F(Kezd) * (Vég - Kezd) / (F(Vég) - F(Kezd)) ' a (Kezd, F(Kezd)) és (Vég, F(Vég)) koordinátájú pontokon áthaladó húr és az x-tengely metszéspontja
            If F(Osztópont) > 0 Then
                Kezd = Osztópont
            Else
                Vég = Osztópont
            End If
            Lépésszám += 1
        Loop While Math.Abs(Osztópont - Előző) >= 0.01 ' csak becslés a hibára
        Label4.Text = "x (becsült érték): " & Osztópont & vbNewLine
        Label4.Text &= "Hibakorlát (becsült érték): " & Math.Abs(Osztópont - Előző) & vbNewLine
        Label4.Text &= "Lépésszám: " & Lépésszám
    End Sub
End Class
