﻿Imports System.IO

Public Class Form1
    Structure TCella
        Dim Fal As Boolean ' fal van-e a cella helyén
        Dim Jobbra, Le As Boolean ' szabad-e a megadott irányba lépni a celláról
        Dim Honnan As String ' honnan léptünk a cellára (Fentről, Balról)
    End Structure

    Dim Tábla(,) As TCella
    Dim MaxSor, MaxOszlop As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim Sor, Oszlop As Integer
        Dim Kész As Boolean

        Label1.Text = ""
        Feltölt()
        Kiír()

        Sor = 1
        Oszlop = 1
        Útkeresés(Sor, Oszlop, Kész)
        If Kész Then
            Útkiír()
            MegoldKiír()
        Else
            Label1.Text &= "Nincs megoldás." & vbNewLine
        End If

        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub Útkeresés(ByRef Sor As Integer, ByRef Oszlop As Integer, ByRef Kész As Boolean)
        Kész = (Sor = MaxSor And Oszlop = MaxOszlop)
        Do While Not Kész And Sor >= 1 And Oszlop >= 1
            ' A következő lépés keresése:
            If Tábla(Sor, Oszlop).Jobbra Then ' jobbra lépünk
                Tábla(Sor, Oszlop).Jobbra = False
                Oszlop += 1
                Tábla(Sor, Oszlop).Honnan = "Balról"
            ElseIf Tábla(Sor, Oszlop).Le Then ' lefelé lépünk
                Tábla(Sor, Oszlop).Le = False
                Sor += 1
                Tábla(Sor, Oszlop).Honnan = "Fentről"
            Else ' visszalépünk
                If Not Tábla(Sor, Oszlop + 1).Fal Then Tábla(Sor, Oszlop).Jobbra = True
                If Not Tábla(Sor + 1, Oszlop).Fal Then Tábla(Sor, Oszlop).Le = True
                If Tábla(Sor, Oszlop).Honnan = "Balról" Then ' balról jöttünk
                    Oszlop -= 1
                Else ' fentről jöttünk
                    Sor -= 1
                End If
            End If
            Kész = (Sor = MaxSor And Oszlop = MaxOszlop)
        Loop
    End Sub

    Sub Feltölt()
        Dim Fájlbe As StreamReader
        Dim Sor, Út As String
        Dim I, J As Integer

        Út = TextBox1.Text
        Fájlbe = New StreamReader(Út)
        MaxSor = Fájlbe.ReadLine
        MaxOszlop = MaxSor
        ReDim Tábla(MaxSor + 1, MaxOszlop + 1)
        I = 1
        Do While Not Fájlbe.Peek
            Sor = Fájlbe.ReadLine
            For J = 0 To Sor.Length - 1
                Select Case Sor(J)
                    Case "x" : Tábla(I, J + 1).Fal = True
                    Case "." : Tábla(I, J + 1).Fal = False
                End Select
            Next
            I += 1
        Loop
        Fájlbe.Close()
        Fájlbe.Dispose()

        For I = 1 To MaxSor
            For J = 1 To MaxOszlop
                Tábla(I, J).Jobbra = (Not Tábla(I, J + 1).Fal)
                Tábla(I, J).Le = (Not Tábla(I + 1, J).Fal)
            Next
        Next
        For I = 0 To MaxSor + 1 ' a szélek feltöltése
            Tábla(0, I).Fal = True
            Tábla(MaxSor + 1, I).Fal = True
            Tábla(I, 0).Fal = True
            Tábla(I, MaxOszlop + 1).Fal = True
        Next
        For I = 1 To MaxSor
            Tábla(I, MaxOszlop).Jobbra = False
            Tábla(MaxSor, I).Le = False
        Next
        ' Bejárat, kijárat:
        Tábla(1, 0).Fal = False
        Tábla(MaxSor, MaxOszlop + 1).Fal = False
    End Sub

    Sub Kiír()
        Dim Temp As String

        Temp = ""
        For I = 0 To MaxSor + 1
            For J = 0 To MaxOszlop + 1
                If Tábla(I, J).Fal Then
                    Temp &= "X"
                Else
                    Temp &= " "
                End If
            Next
            Temp &= vbNewLine
        Next
        Label1.Text &= Temp & vbNewLine
    End Sub

    Sub Útkiír()
        Dim Temp As String
        Dim Sor, Oszlop As Integer

        Temp = vbNewLine
        Sor = MaxSor
        Oszlop = MaxOszlop
        Do While Not (Sor = 1 And Oszlop = 1)
            Select Case Tábla(Sor, Oszlop).Honnan
                Case "Balról" : Temp = "J" & Temp : Oszlop -= 1
                Case "Fentről" : Temp = "L" & Temp : Sor -= 1
            End Select
        Loop
        Temp &= vbNewLine
        Label1.Text &= "Lépések: " & Temp
    End Sub

    Sub MegoldKiír()
        Dim Megold(MaxSor + 1, MaxOszlop + 1) As Char
        Dim I, J As Integer
        Dim Temp As String

        For I = 0 To MaxSor + 1
            For J = 0 To MaxOszlop + 1
                If Tábla(I, J).Fal Then
                    Megold(I, J) = "X"
                Else
                    Megold(I, J) = " "
                End If
            Next
        Next
        I = MaxSor
        J = MaxOszlop
        Do While Not (I = 1 And J = 1)
            Megold(I, J) = "O"
            Select Case Tábla(I, J).Honnan
                Case "Balról" : J -= 1
                Case "Fentről" : I -= 1
            End Select
        Loop
        Megold(I, J) = "O"
        Temp = ""
        For I = 0 To MaxSor + 1
            For J = 0 To MaxOszlop + 1
                Temp &= Megold(I, J)
            Next
            Temp &= vbNewLine
        Next
        Label1.Text &= Temp & vbNewLine
    End Sub
End Class

