﻿Public Class Form1
    Structure TDiák
        Dim Magasság As Integer
        Dim Fiú As Boolean
    End Structure
    Structure TSorozat
        Dim Diák() As TDiák
        Dim Elemszám As Integer 'azért vezetjük be, hogy szemléletesebb legyen a hivatkozás (a GetUpperBound helyett)
    End Structure

    Const MinSor As Integer = 3 ' legalább ennyi sorozat van
    Const MaxSor As Integer = 5 ' legfeljebb ennyi sorozat van
    Const MinDiák As Integer = 3 ' legalább ennyi diák van egy sorozatban
    Const MaxDiák As Integer = 15 ' legfeljebb ennyi diák van egy sorozatban
    Const MinMagasság As Integer = 120 ' legalább ilyen magas egy diák
    Const MaxMagasság As Integer = 180 ' legfeljebb ilyen magas egy diák

    Dim Sorozat() As TSorozat
    Dim Megold() As Integer
    Dim Db As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim I As Integer
        Dim Van As Boolean

        Label1.Text = ""
        Feltölt()
        Db = 0
        Kiír()
        Label1.Text &= "Megoldások:" & vbNewLine

        ÖsszesMegoldás(Van)

        If Db = 0 Then
            Label1.Text &= "nincs megoldás"
        End If
    End Sub

    Sub ÖsszesMegoldás(ByRef Van As Boolean)
        Dim I, Melyik As Integer

        Array.Clear(Megold, 0, Megold.Length)
        I = 1
        Do While I >= 1
            ElemetKeres(I, Van, Melyik) ' az I-edik sorozatban van-e megfelelő elem, és ha igen, akkor melyik az
            If Van Then ' rátérünk a következő sorozatra
                Megold(I) = Melyik
                I += 1
            Else ' visszalépünk az előző sorozatra
                Megold(I) = 0
                I -= 1
            End If
            Van = (I > Sorozat.GetUpperBound(0))
            If Van Then
                Db += 1
                Label1.Text &= String.Format("{0,3}.: ", Db)
                MegoldKiír()
                I -= 1 ' Fontos! Visszalépés az előző sorozatra.
            End If
        Loop
    End Sub

    Sub ElemetKeres(ByVal I As Integer, ByRef Van As Boolean, ByRef Melyik As Integer)
        ' az I-edik sorozatban találunk-e megfelelő elemet, és ha igen, akkor melyik az
        Melyik = Megold(I) + 1 ' kiindulunk a következő elemtől (a visszalépések miatt), először az 1. elemtől
        Do While Melyik <= Sorozat(I).Elemszám AndAlso (Not Választható(I, Melyik) Or NemJó(I, Melyik))
            Melyik += 1
        Loop
        Van = (Melyik <= Sorozat(I).Elemszám)
    End Sub

    Function NemJó(ByVal I As Integer, ByVal Melyik As Integer)
        ' Az I-edik sorozat Melyik elemét összehasonlítjuk az eddigi választásokkal
        ' (itt most elegendő lenne csak az előző elemmel összehasonlítani, de általánosítunk)
        Dim J As Integer
        J = 1
        Do While J < I And Megfelelő(I, Melyik, J)
            J += 1
        Loop
        NemJó = (J < I)
    End Function

    Function Választható(ByVal I As Integer, ByVal Melyik As Integer)
        Választható = Sorozat(I).Diák(Melyik).Fiú
    End Function

    Function Megfelelő(ByVal I As Integer, ByVal Melyik As Integer, ByVal J As Integer)
        Megfelelő = Sorozat(J).Diák(Megold(J)).Magasság < Sorozat(I).Diák(Melyik).Magasság
    End Function

    Sub Feltölt()
        Dim Vélszám As Random = New Random
        Dim I, J As Integer

        ReDim Sorozat(Vélszám.Next(MinSor, MaxSor + 1))
        For I = 1 To Sorozat.GetUpperBound(0)
            ReDim Sorozat(I).Diák(Vélszám.Next(MinDiák, MaxDiák + 1))
            Sorozat(I).Elemszám = Sorozat(I).Diák.GetUpperBound(0)
            For J = 1 To Sorozat(I).Elemszám
                Sorozat(I).Diák(J).Magasság = Vélszám.Next(MinMagasság, MaxMagasság + 1)
                Sorozat(I).Diák(J).Fiú = (Vélszám.Next(2) = 0)
            Next
        Next
        ReDim Megold(Sorozat.GetUpperBound(0))
    End Sub

    Sub Kiír()
        Dim I, J As Integer
        Dim Temp As String

        Temp = vbNewLine
        For I = 1 To Sorozat.GetUpperBound(0)
            For J = 1 To Sorozat(I).Diák.GetUpperBound(0)
                If Sorozat(I).Diák(J).Fiú Then
                    Temp &= "F"
                Else
                    Temp &= "L"
                End If
                Temp &= Sorozat(I).Diák(J).Magasság & " "
            Next
            Temp &= vbNewLine
        Next
        Label1.Text &= Temp & vbNewLine
    End Sub

    Sub MegoldKiír()
        Dim I As Integer
        Dim Temp As String

        Temp = ""
        For I = 1 To Megold.GetUpperBound(0)
            Temp &= "F" & Sorozat(I).Diák(Megold(I)).Magasság & " "
        Next
        Label1.Text &= Temp & vbNewLine
    End Sub
End Class
