﻿' Dinamikus programozás
' Leghosszabb közös részsorozat

Public Class Form1
    Dim MaxindexS1, MaxindexS2 As Integer ' a két sorozat maximális indexe
    Dim S1(), S2() As Integer   ' a két sorozat
    Dim Honnan(,) As String     ' honnan érkeztünk az (I,J) cellába
    Dim Táblázat(,) As Integer  ' táblázat a megoldás meghatározásához
    Dim I, J As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Feltölt()

        ' A keresés algoritmusa:
        For I = 1 To MaxindexS1
            Táblázat(I, 0) = 0
        Next
        For J = 0 To MaxindexS2
            Táblázat(0, J) = 0
        Next
        For I = 1 To MaxindexS1
            For J = 1 To MaxindexS2
                If S1(I) = S2(J) Then ' egyforma a két elem
                    Táblázat(I, J) = Táblázat(I - 1, J - 1) + 1
                    Honnan(I, J) = "↖"
                ElseIf Táblázat(I - 1, J) >= Táblázat(I, J - 1) Then ' a fölötte lévő érték nagyobb vagy egyenlő, mint a balra lévő
                    Táblázat(I, J) = Táblázat(I - 1, J)
                    Honnan(I, J) = "↑"
                Else ' a balra lévő nagyobb, mint a fölötte lévő
                    Táblázat(I, J) = Táblázat(I, J - 1)
                    Honnan(I, J) = "←"
                End If
            Next
        Next

        Kiír()
    End Sub

    Sub Feltölt()
        ' A tömbök feltöltése
        Dim I, J
        Dim Vélszám As New Random

        MaxindexS1 = Vélszám.Next(10, 20)
        MaxindexS2 = Vélszám.Next(10, 20)
        ReDim S1(MaxindexS1)
        ReDim S2(MaxindexS2)
        ReDim Honnan(MaxindexS1, MaxindexS2)
        ReDim Táblázat(MaxindexS1, MaxindexS2)
        For I = 1 To MaxindexS1
            S1(I) = Vélszám.Next(1, 10)
        Next
        For I = 1 To MaxindexS2
            S2(I) = Vélszám.Next(1, 10)
        Next

        ' A tankönyvben szereplő példa (tesztelésehez):
        'S1 = New Integer() {0, 1, 2, 3, 2, 4, 1, 2}
        'S2 = New Integer() {0, 2, 4, 3, 1, 2, 1}
        'MaxindexS1 = S1.GetUpperBound(0)
        'MaxindexS2 = S2.GetUpperBound(0)

        For I = 0 To MaxindexS1
            For J = 0 To MaxindexS2
                Honnan(I, J) = " "
            Next
        Next
    End Sub

    Sub Kiír()
        ' Az eredmények kiírása
        Dim Temp As String
        Dim I, J As Integer

        ' Előállítjuk a közös részsorozat elemeit
        Temp = ""
        I = MaxindexS1
        J = MaxindexS2
        Do While Honnan(I, J) <> " "
            Select Case Honnan(I, J)
                Case "↑"
                    I -= 1
                Case "←"
                    J -= 1
                Case "↖"
                    Temp = S1(I) & " " & Temp
                    S1(I) = -S1(I) ' megjelöljük az elemeket (a sorozatok kiírásához kell)
                    S2(J) = -S2(J)
                    I -= 1
                    J -= 1
            End Select
        Loop
        Temp = "A leghosszabb közös részsorozat elemszáma: " & Táblázat(MaxindexS1, MaxindexS2) & vbNewLine & "Elemei: " & Temp
        Label2.Text = Temp

        Temp = "A sorozatok:" & vbNewLine
        For I = 1 To MaxindexS1
            If S1(I) > 0 Then
                Temp &= " " & S1(I) & " "
            Else
                Temp &= "|" & Math.Abs(S1(I)) & "|"
            End If
            Temp &= " "
        Next
        Temp &= vbNewLine
        For I = 1 To MaxindexS2
            If S2(I) > 0 Then
                Temp &= " " & S2(I) & " "
            Else
                Temp &= "|" & Math.Abs(S2(I)) & "|"
            End If
            Temp &= " "
        Next
        Label1.Text = Temp

        Temp = "A megoldáshoz vezető táblázat:" & vbNewLine & "   "
        For I = 0 To MaxindexS2
            Temp &= Math.Abs(S2(I)) & "  "
        Next
        Temp &= vbNewLine
        For I = 0 To MaxindexS1
            Temp &= Math.Abs(S1(I)) & ": "
            For J = 0 To MaxindexS2
                Temp &= Táblázat(I, J) & "  "
            Next
            Temp &= vbNewLine
        Next
        Temp &= vbNewLine

        Temp &= "A Honnan táblázat:" & vbNewLine & "   "
        For I = 0 To MaxindexS2
            Temp &= Math.Abs(S2(I)) & "  "
        Next
        Temp &= vbNewLine
        For I = 0 To MaxindexS1
            Temp &= Math.Abs(S1(I)) & ": "
            For J = 0 To MaxindexS2
                Temp &= Honnan(I, J) & "  "
            Next
            Temp &= vbNewLine
        Next
        Label3.Text = Temp
    End Sub
End Class

