﻿' 0-1 hátizsák-feladat
' Megoldás dinamikus programozással

Public Class Form1
    Dim MaxSúly As Integer ' a súly maximális értéke (ennyit tud egyszerre elvinni)
    Dim Súly() As Integer ' a tárgyak súlya
    Dim Érték() As Integer ' a tárgyak értéke
    Dim Viszi() As Boolean ' elvisszük-e az adott indexű súlyt
    Dim Táblázat(,) As Integer ' táblázat a megoldás meghatározásához
    Dim Honnan(,) As String ' honnan érkeztünk az (I,J) cellába
    Dim N As Integer ' a tárgyak max. indexe
    Dim I, J As Integer
    Dim Vélszám As New Random
    Dim e As New System.EventArgs
    Dim sender As New Object

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        MaxSúly = TextBox1.Text
        ReDim Táblázat(MaxSúly, N)
        ReDim Honnan(MaxSúly, N)
        ReDim Viszi(N)

        'A Viszi tömb feltöltése
        For J = 0 To N
            Viszi(J) = False
        Next

        ' A Honnan tömb feltöltése
        For I = 0 To MaxSúly
            For J = 0 To N
                Honnan(I, J) = "←"
            Next
        Next

        ' A 0 kg-os maximális súlyhoz tartozó (0. indexű) sor kitöltése
        ' (nem tudunk elvinni semmit)
        For J = 0 To N
            Táblázat(0, J) = 0
        Next

        ' A Súly(0)-hoz tartozó, 0. indexű oszlop kitöltése
        For I = 0 To Math.Min(MaxSúly, Súly(0) - 1) ' lehet, hogy a legkisebb súlyt sem tudjuk elvinni
            Táblázat(I, 0) = 0 ' nem tudjuk elvinni
        Next
        For I = Súly(0) To MaxSúly
            Táblázat(I, 0) = Érték(0) ' el tudjuk vinni
            Honnan(I, 0) = "↑"
        Next

        ' A táblázat többi elemének kitöltése (dinamikus progamozás)
        For I = 1 To MaxSúly ' legfeljebb I font súlyt tudunk elvinni
            For J = 1 To N ' a 0.-tól a J-edik oszlopig választunk tárgyat (a 0. oszlopot már kitöltöttük)
                If Súly(J) > I Then
                    Táblázat(I, J) = Táblázat(I, J - 1)
                ElseIf Táblázat(I, J - 1) > Érték(J) + Táblázat(I - Súly(J), J - 1) Then
                    Táblázat(I, J) = Táblázat(I, J - 1)
                Else
                    Táblázat(I, J) = Érték(J) + Táblázat(I - Súly(J), J - 1)
                    Honnan(I, J) = "↑"
                End If
            Next
        Next

        EredményKiír()
        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub Feltölt()
        N = Vélszám.Next(1, 10)
        ReDim Súly(N)
        ReDim Érték(N)
        For I = 0 To N
            Súly(I) = Vélszám.Next(1, 10)
            Érték(I) = Vélszám.Next(1, 10)
        Next
        Array.Sort(Súly, Érték) ' rendezi a tömböket a súly szerint
        SorozatKiír()
        Label1.Text = ""
        RichTextBox1.Text = ""
        TextBox1.Focus()
        TextBox1.SelectAll()

        Button1_Click(sender, e)
    End Sub

    Sub SorozatKiír()
        Dim Temp As String = " "

        For I = 1 To N + 1
            Temp &= String.Format("{0,3}.", I)
        Next
        Temp &= vbNewLine
        For I = 0 To N
            Temp &= String.Format("{0,4}", Súly(I))
        Next
        Temp &= " font" & vbNewLine
        For I = 0 To N
            Temp &= String.Format("{0,4}", Érték(I))
        Next
        Temp &= " dénár"
        Label2.Text = Temp
    End Sub

    Sub EredményKiír()
        Dim Temp As String
        Dim SúlyÖssz, ÉrtékÖssz As Integer

        Temp = "A megoldáshoz vezető táblázat" & vbNewLine
        Temp &= "(adott max. súly esetén hány dénár értékben tud elvinni tárgyakat):" & vbNewLine & vbNewLine
        Temp &= "       Tárgyak:" & vbNewLine
        Temp &= "Max. "
        For J = 0 To N
            Temp &= String.Format("{0,4}  ", Súly(J))
        Next
        Temp &= "font" & vbNewLine & "súly:"
        For J = 0 To N
            Temp &= String.Format("{0,4}  ", Érték(J))
        Next
        Temp &= "dénár" & vbNewLine
        For I = 0 To MaxSúly
            Temp &= String.Format("{0,3}: ", I)
            For J = 0 To N
                Temp &= String.Format("{0,4}  ", Táblázat(I, J))
            Next
            Temp &= vbNewLine
        Next
        Temp &= vbNewLine

        Temp &= "A Honnan táblázat" & vbNewLine
        Temp &= "       Tárgyak:" & vbNewLine
        Temp &= "Max. "
        For J = 0 To N
            Temp &= String.Format("{0,4}  ", Súly(J))
        Next
        Temp &= "font" & vbNewLine & "súly:"
        For J = 0 To N
            Temp &= String.Format("{0,4}  ", Érték(J))
        Next
        Temp &= "dénár" & vbNewLine
        For I = 0 To MaxSúly
            Temp &= String.Format("{0,3}: ", I)
            For J = 0 To N
                Temp &= "   " & Honnan(I, J) & "  "
            Next
            Temp &= vbNewLine
        Next
        RichTextBox1.Text = Temp & vbNewLine

        ' A Viszi tömb feltöltése (mely tárgyakat vittük el):
        I = MaxSúly
        J = N
        Do While Not (I < 0 Or J < 0)
            Select Case Honnan(I, J)
                Case "←"
                    J -= 1
                Case Else ' "↑"
                    Viszi(J) = True
                    I -= Súly(J)
                    J -= 1
            End Select
        Loop

        Temp = "Elvitt tárgyak" & vbNewLine
        Temp &= "Súly:      Érték:" & vbNewLine
        SúlyÖssz = 0
        ÉrtékÖssz = 0
        For J = 0 To N
            If Viszi(J) Then
                Temp &= String.Format("{0,4}        {1,4}", Súly(J), Érték(J)) & vbNewLine
                SúlyÖssz += Súly(J)
                ÉrtékÖssz += Érték(J)
            End If
        Next
        Temp &= "----------------------" & vbNewLine
        Temp &= String.Format("{0,4} font   {1,4} dénár", SúlyÖssz, ÉrtékÖssz)

        ' Ellenőrzés:
        Temp &= vbNewLine & vbNewLine & "Ellenőrzés:" & vbNewLine
        If SúlyÖssz <= MaxSúly Then
            Temp &= "súly rendben."
        Else
            Temp &= "súly hibás."
        End If
        Temp &= vbNewLine
        If ÉrtékÖssz = Táblázat(MaxSúly, N) Then
            Temp &= "érték rendben."
        Else
            Temp &= "érték hibás."
        End If

        Label1.Text = Temp
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Súly = New Integer() {1, 2, 3} ' a tárgyak súlya
        Érték = New Integer() {3, 5, 6} ' a tárgyak értéke
        N = Súly.GetUpperBound(0)
        SorozatKiír()
        Button1_Click(sender, e)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Feltölt()
        Button1_Click(sender, e)
    End Sub
End Class
